
"""
__version__ = "$Revision: 1.7 $"
__date__ = "$Date: 2003/01/13 17:49:32 $"
"""

#from wxPython import wx

# these should be in some common place
# since they are used in widget.py as well
MAGIC_GET_PREFIX = '_get'
MAGIC_SET_PREFIX = '_set'



class StatusBar :

    def __init__( self, parent ) :
        attributes = ['_delegate', '_text']
        self._createAttributes(attributes)
        self._text = ''
        #self._delegate = wx.wxStatusBar(parent, wxNewId())
        self._delegate = parent.CreateStatusBar()


    def _getAttributeNames(self):
        """Return list of magic attributes to extend introspection.
        
        Returns only attributes having both "get" and "set" methods.
        Unlike dir(), this method does walk up its inheritance tree."""
        listX = []
        dictX = {}
        # Remove duplicates from the attribute list.
        for item in self._getAllAttributeNames(object=self):
            dictX[item] = None
        listX += dictX.keys()
        listX.sort()
        return listX

    def _getAllAttributeNames(self, object):
        """Return list of all magic attributes for an object.
        
        Recursively walk through a class and all base classes."""
        listX = []
        for name in dir(object):
            # Is this one of our magic "get" methods?
            if name.startswith(MAGIC_GET_PREFIX):
                # Remove the prefix from the name.
                name = name[len(MAGIC_GET_PREFIX):]
                # Check for a corresponding "set" method.
                if name and hasattr(self, MAGIC_SET_PREFIX + name):
                    # Add the stripped down name to our list.
                    listX.append(name[0].lower() + name[1:])
        # Get any magic attributes for the class.
        if hasattr(object, '__class__'):
            listX += self._getAllAttributeNames(object.__class__)
        # Also get attributes from any and all parent classes.
        if hasattr(object, '__bases__'):
            for base in object.__bases__:
                listX += self._getAllAttributeNames(base)
        return listX

    def __getattr__(self, name):
        if not name.startswith(MAGIC_GET_PREFIX) and name[0].islower():
            callName = MAGIC_GET_PREFIX + name[0].upper() + name[1:]
            return getattr(self, callName)()
        else:
            raise AttributeError, name

    def __setattr__(self, name, value):
        if name in self.__dict__:
            self.__dict__[name] = value
        elif not name.startswith(MAGIC_SET_PREFIX) and name[0].islower():
            callName = MAGIC_SET_PREFIX + name[0].upper() + name[1:]
            try:
                method = getattr(self, callName)
            except:
                raise AttributeError, name
            return method(value)
        else:
            raise AttributeError, name
        
    def _createAttributes(self, attrList):
        for attr in attrList:
            if attr not in self.__dict__:
                self.__dict__[attr] = None


    def _getText(self):
        return self._text

    def _setText(self, aString):
        self._text = aString
        self._delegate.SetStatusText(aString)
